config/routes.rb
Rails.application.routes.draw do

  # Landing page
  root to: 'site/home#index'

  # Devise routes
  devise_for :users,
    path: '',
    controllers: {
      sessions:      'admin/sessions',
      registrations: 'admin/registrations'
    },
    path_names: {
      sign_in:      '/admin/login',
      password:     '/admin/forgot',
      confirmation: '/admin/confirm',
      unlock:       '/admin/unblock',
      registration: '/admin/register',
      sign_up:      '/admin/new',
      sign_out:     '/admin/logout'
    }

  devise_for :customers,
    path: '',
    controllers: {
      sessions:      'site/sessions',
      registrations: 'site/registrations',
      passwords:     'site/passwords'
    },
    path_names: {
      sign_in:      '/login',
      password:     '/customer/forgot',
      confirmation: '/customer/confirm',
      unlock:       '/customer/unblock',
      registration: 'register',
      sign_up:      '/login',
      sign_out:     '/customer/logout'
    }

  as :user do
    delete 'admin/logout', to: 'admin/sessions#destroy'
  end

  as :customer do
    resource :my_account,     module: 'site', path: 'my-account'

    get    'order-history',   to: 'site/my_accounts#order_history'
    get    'register',        to: 'site/registrations#new'
    get    'login',           to: 'site/sessions#new'
    delete 'customer/logout', to: 'site/sessions#destroy'
  end
  # End Devise routes

  # Site routes
  namespace :site do
    resource :cart_items
    resource :messages
    resources :orders
    resource :product_reviews
    resource :newsletter_subscribers

    # Data retrieval through AJAX.
    scope '/json' do
      post 'filter_skus',  to: 'filter_skus#filter_skus'
      post 'shipping-fee', to: 'checkout#update_shipping'
      post 'retrieve_cities', to: 'cities#retrieve_cities'
    end
  end

  # Paynamics routes.
  scope '/paynamics/notification' do
    post 'sales', to: 'site/paynamics_responses#paynamics_sales_response'
  end

  get 'brands/:slug',         to: 'site/brands#show'
  get 'cart',                 to: 'site/cart#show'
  get 'checkout',             to: 'site/checkout#index'
  get 'checkout/payment',     to: 'site/checkout#payment'
  get 'company-details',      to: 'site/company_details#index'
  get 'contact-us',           to: 'site/contact_us#index'
  get 'faqs',                 to: 'site/faqs#index'
  get 'privacy-policy',       to: 'site/privacy_policy#index'
  get 'search',               to: 'site/search#index'
  get 'shipping',             to: 'site/shipping_details#index'
  get 'shop',                 to: 'site/shop#index'
  get 'shop/:slug',           to: 'site/shop#show'
  get 'terms-and-conditions', to: 'site/terms#index'
  # get 'vpc-checkout',         to: 'site/checkout#vpc_checkout'
  get 'paynamics-checkout',   to: 'site/checkout#paynamics_checkout'
  get 'verify-paynamics',     to: 'site/payments#paynamics_verification' 
  get 'thank-you',            to: 'site/payments#thank_you'
  
  # Mockup routes
  get 'mockups/cookie-policy', to: 'site/mockups#cookie_policy'
  # End mockup routes

  # End Site routes

  # Admin routes
  namespace :admin do
    # Redirect /admin to the dashboard page.
    root to: redirect('admin/dashboard')

    resources :advertisements
    resources :audittrails
    resources :brands
    resources :careers
    resources :dashboard
    resources :categories
    resources :faqs
    resources :inventories
    resources :messages
    resources :orders
    resources :profile
    resources :products
    resources :roles
    resources :subcategories
    resources :terms
    resources :users
    resources :product_reviews,       path: 'product-reviews' 
    resources :company_details,       path: 'company-details'
    resources :order_statuses,        path: 'order-statuses'
    resources :privacy_policies,      path: 'privacy-policy'
    resources :shipping_rates,        path: 'shipping-rates'
    resources :price_updates,         path: 'price-updates' do
      post 'get_sku_price', on: :collection
    end
    resources :dhl_shipper_accounts, path: 'dhl-shipper-settings'
    resources :dhl_products,         path: 'dhl-products'
    resources :dhl_package_types,    path: 'dhl-package-types'
    resources :sliders do
      post 'update_slider_status', on: :collection
    end
    resources :photos do
      collection do
        get 'load_more_photos'
        get 'refresh_photos_list'
      end
    end

    # Maintenance routes.
    scope '/maintenance' do
      resources :uom_labels, path: 'uom-labels'
      resources :uoms
    end

    # Data retrieval through AJAX.
    scope '/json' do
      post 'retrieve_sub_categories',   to: 'products#retrieve_sub_categories'
      post 'retrieve_order_details',    to: 'orders#retrieve_order_details'
      post 'retrieve_dhl_status',       to: 'dhl#tracking'
    end
    
    scope '/dhl' do
      post 'validate-shipment/:order_request_id', to: 'dhl#validate_shipment'
      post 'book-pickup/:order_request_id',       to: 'dhl#book_pickup'
      post 'modify-pickup/:order_request_id',     to: 'dhl#modify_pickup'
      post 'cancel-pickup/:order_request_id',     to: 'dhl#cancel_pickup'
      get  'label-image/:order_request_id',       to: 'dhl#label_image'
    end

    # DataTable retrieval routes.
    scope '/datatables' do
      post 'retrieve_advertisements',       to: 'advertisements#populate_datatables'
      post 'retrieve_audittrails',          to: 'audittrails#populate_datatables'
      post 'retrieve_brands',               to: 'brands#populate_datatables'
      post 'retrieve_careers',              to: 'careers#populate_datatables'
      post 'retrieve_categories',           to: 'categories#populate_datatables'
      post 'retrieve_faqs',                 to: 'faqs#populate_datatables'
      post 'retrieve_inventories',          to: 'inventories#populate_datatables'
      post 'retrieve_show_inventories',     to: 'inventories#populate_show_datatables'
      post 'retrieve_messages',             to: 'messages#populate_datatables'
      post 'retrieve_orders',               to: 'orders#populate_datatables'
      post 'retrieve_order_statuses',       to: 'order_statuses#populate_datatables'
      post 'retrieve_products',             to: 'products#populate_datatables'
      post 'retrieve_reviews',              to: 'product_reviews#populate_datatables'
      post 'retrieve_product_reviews',      to: 'product_reviews#populate_review_datatables'
      post 'retrieve_roles',                to: 'roles#populate_datatables'
      post 'retrieve_subcategories',        to: 'subcategories#populate_datatables'
      post 'retrieve_uom_labels',           to: 'uom_labels#populate_datatables'
      post 'retrieve_uoms',                 to: 'uoms#populate_datatables'
      post 'retrieve_users',                to: 'users#populate_datatables'
      post 'retreive_price_list',           to: 'price_updates#populate_datatables'
      post 'retreive_price_history',        to: 'price_updates#populate_history_datatables'
      post 'retreive_shipping_rates',       to: 'shipping_rates#populate_datatables'
      post 'retrieve_dhl_products',         to: 'dhl_products#populate_datatables'
      post 'retrieve_dhl_package_types',    to: 'dhl_package_types#populate_datatables'
    end
  end
  # End Admin routes
end

app/controllers/site/brands_controller.rb
module Site
  class BrandsController < SiteController
    before_action :set_cache_headers
    def show
      id          = params[:slug].split("-")[0].to_i
      @brand      = Brand.find(id)
      @categories = Division.active_categories
      @skus       = Sku.active_skus.by_brand(id)
    end
  end
end

app/controllers/site/cart_controller.rb
module Site
  class CartController < SiteController
    
    def index
    end
    
    def show
    end
  end
end

app/controllers/site/cart_items_controller.rb
module Site
  class CartItemsController < SiteController

    before_action :set_cart_item, only: [:update, :destroy]

    def create
      @cart_item = @cart.add_item(cart_item_params)
      @cart_item.save
      
      @skus = Sku.find(cart_item_params[:sku_id]).product.skus
    end

    def update
      @cart.update_item(@cart_item, params[:method])
    end

    def destroy
      @skus = @cart_item.sku.product.skus
      
      @cart_item.destroy
    end

    private
      def cart_item_params
        params.require(:cart_item).permit(:quantity, :sku_id, :method)
      end

      def set_cart_item
        @cart_item = @cart.cart_items.find(params[:id])
      end
  end
end

app/controllers/site/checkout_controller.rb
module Site
  class CheckoutController < SiteController
    
    # require 'global_payments/vpc' # for MiGS Virtual Payment Client (Global Payments)
    require 'dhl/get_quote'
    # include VPCConnection
    include ApplicationHelper
    
    before_action :redirect_if_not_signed_in
    before_action :set_cache_headers, only: [:index]
    skip_before_action :verify_authenticity_token, only: [:paynamics_checkout]

    def index
      respond_to do |format|
        @order = @cart.order.present? ? @cart.order : @cart.build_order
        @countries = Country.active_countries_from_shipping
        @couriers = [{:name=>'Xend', :id=>1}, {:name=>'DHL', :id=>2}]
        province_id           = @addresses && @addresses.size > 0 ? @addresses.first.state_id : nil
        @shipping_states      = Province.all
        @shipping_cities      = (@order.present?) && @order.shipping_state_id.present? ? City.where(province_id: @order.shipping_state_id): []
        if current_customer.shipping_country_code.present?
          check_restrited_products(current_customer.shipping_country_code)
        end
        format.js
        format.html
      end
    end
    
    def payment
      respond_to do |format|
        @order = @cart.order
        format.js
        format.html
      end
    end
    
    def update_shipping
      shipping_rate_id = params[:shipping_rate_id]
      shipping_country_code = params[:shipping_country_code]
      postal_code = params[:postal_code]
      courier_id = params[:courier_id]
      
      if courier_id.to_i == 1 || shipping_country_code == "PH" # Xend 
        @shipping_rate = ShippingRate.find(shipping_rate_id)
        @shipping_fee = @shipping_rate.get_shipping_price(@cart.total_weight)
      elsif courier_id.to_i == 2 # DHL 
        dhl_get_quote(shipping_country_code, postal_code)
      end
      check_restrited_products(shipping_country_code)
    end
    
    def dhl_get_quote(country_code, postal_code)
      request = GetQuoteRequest.new
      
      request.metric_measurements!

      # r.add_special_service("DD")

      request.to(country_code, postal_code)
      request.from('PH', 1106) # Vida NutriScience's country code and zip code 
      
      request.pieces << GetQuotePiece.new(:weight => @cart.total_weight)

      response = request.post
      if response.error? 
        @dhl_error = response.error
        puts flash[:dhl_error]
      elsif response.total_amount.to_f == 0
        @dhl_error = "Something went wrong!"
      else
        @shipping_fee = response.total_amount || 0
      end
    end
    
    # MiGS Virtual Payment Clent API (Global Payments)
    def vpc_checkout
      total_amount = @cart.subtotal + @cart.order.shipping_fee
      VPC_GATEWAY.setup_purchase(
        vpc_Amount:         (total_amount * 100).to_i,
        vpc_Command:        'pay',
        vpc_Locale:         'en',
        vpc_MerchTxnRef:    @cart.order.request_id,
        vpc_Merchant:       (ENV["PAYMENT_API_MODE"] == "live") ? ENV["VPC_MERCHANT_ID"] : 'gpmnl073002798001',
        vpc_OrderInfo:      @cart.order.request_id,
        vpc_ReturnURL:      root_url.to_s + 'thank-you',
        vpc_Version:        1
      )
      puts VPC_GATEWAY.get_vpc_url
      redirect_to VPC_GATEWAY.get_vpc_url
    end
    
    # Paynamics Checkout.
    def paynamics_checkout
      client   = Paynamics.client
      @payload = client.build_purchase_payload(paynamics_purchase_options)
      
      unless @payload.present?
        flash[:alert] = "A problem has been encountered while placing your order. Please try again."
        redirect_to checkout_path
      end
    end
    
    private
      def check_restrited_products(country_code)
        @restricted_sku_ids = []
        @cart.cart_items.each do |ci|
          @restricted_sku_ids << ci.sku.id if ci.sku.product.restricted_country_codes.include? country_code
        end
      end
      
      # Generate the options expected by paynamics api.
      def paynamics_purchase_options
        total_amount = @cart.subtotal + @cart.order.shipping_fee
        
        purchase_options = {
          request_id:               @cart.order.request_id,
          ip_address:               '174.129.25.170',
          notification_url:         ENV["PAYNAMICS_VIDA_NOTIFICATION_URL"],
          response_url:             ENV["PAYNAMICS_VIDA_RESPONSE_URL"],
          cancel_url:               ENV["PAYNAMICS_VIDA_CANCEL_URL"],
          cart_id:                  @cart.order.cart_id,
          customer_id:              @cart.order.customer_id,
          fname:                    @cart.order.first_name,
          mname:                    @cart.order.middle_name,
          lname:                    @cart.order.last_name,
          email:                    @cart.order.email,
          phone:                    @cart.order.phone,
          mobile:                   @cart.order.mobile,
          address1:                 @cart.order.shipping_address1,
          address2:                 @cart.order.shipping_address2,
          city:                     @cart.order.shipping_city,
          state:                    @cart.order.shipping_state,
          zip:                      @cart.order.shipping_zip_code,
          country:                  @cart.order.shipping_country_code,
          is_same_shipping_address: 1,
          shipping_address1:        @cart.order.shipping_address1,
          shipping_address2:        @cart.order.shipping_address2,
          shipping_city:            @cart.order.shipping_city,
          shipping_state:           @cart.order.shipping_state,
          shipping_zip:             @cart.order.shipping_zip_code,
          shipping_country:         @cart.order.shipping_country_code,
          secure3d:                 "try3d",
          client_ip:                request.remote_ip,
          pmethod:                  "",
          currency:                 "PHP",
          amount:                   format_number_with_precision_no_delimeter(total_amount, 2),
          mlogo_url: "https://vidanutriscience.s3-ap-southeast-1.amazonaws.com/production/assets/vida-nutriscience-logo-new-2a36bc36f154c8e249223b7c1226f60c973e200fd483d509ac8bfd399b251e9f.png"
        }
        
        # Add the items to options.
        purchase_options[:orders] = purchase_items
        purchase_options
      end
      
      # Generate the items included in the purchase.
      def purchase_items
        orders = []
        
        # Populate the orders.
        # Add the cart items.
        @cart.order.order_items.each do |item|
          orders.push({
            itemname: "#{item.sku.product.name} (#{item.sku.code}: #{item.sku.name})",
            quantity: item.quantity,
            amount:   format_number_with_precision_no_delimeter(item.sku.get_price, 2),
            sku_id:   item.sku.id
          })
        end
        
        # Add the Shipping amount as item.
        orders.push({
          itemname: "Shipping Fee",
          quantity: 1,
          amount: format_number_with_precision_no_delimeter(@cart.order.shipping_fee, 2)
        })
        
        orders
      end
  end
end

app/controllers/site/cities_controller.rb
module Site
  class CitiesController < SiteController
    def retrieve_cities
      cities = City.where(province_id: params[:province_id])
      
      # Return the cities.
      respond_to do |format|
        format.json  { 
          render json: { cities: cities }
        }
      end
    end
  end
end

app/controllers/site/company_details_controller.rb
module Site
  class CompanyDetailsController < SiteController
    before_action :set_cache_headers, only: [:index]
    def index
      @company_details = CompanyDetail.first
    end
  end
end

app/controllers/site/contact_us_controller.rb
module Site
  class ContactUsController < SiteController
    before_action :set_cache_headers, only: [:index]
    def index
      @message = Message.new
    end
  end
end

app/controllers/site/faqs_controller.rb
module Site
  class FaqsController < SiteController
    before_action :set_cache_headers, only: [:index]
    def index
      @faqs = Faq.active_faqs
    end
  end
end

app/controllers/site/filter_skus_controller.rb
module Site
  class FilterSkusController < SiteController
    
    # POST /site/json/filter_skus
    # This method handles the AJAX filtering of products.
    def filter_skus
      # Decode the JSON String parameter passed by browser to 
      # a hash object to be able to read by Ruby.
      @hash = ActiveSupport::JSON.decode(params[:filters]) if params[:filters].present?
      
      if params[:slug].present? # Meaning coming from the brand page.
        id = params[:slug].split("-")[0].to_i
        @skus = Sku.active_skus.by_brand(id)
      else
        @skus = Sku.active_skus
      end
      
      @skus = @skus.reorder(@hash["order_by"]) if @hash["order_by"].present?
      
      # Process the supplied filters.
      @skus = @skus.where("p.brand_id IN (?)", @hash["brands"]) if @hash["brands"].present?
      @skus = @skus.where("p.sub_division_ids && ARRAY[?]", @hash["subcategories"]) if @hash["subcategories"].present?
    end
  end
end

app/controllers/site/mockups_controller.rb
module Site
  class MockupsController < SiteController

  end
end

app/views/site/my_accounts/_links.html.slim
=link_to "My Account", my_account_path, class: "link-customer wrapper-sort mb-5 #{active?(my_account_path)}"
=link_to "Order History", order_history_path, class: "link-customer wrapper-sort #{active?(order_history_path)}"

app/views/site/my_accounts/_welcome.html.slim
.bar
  .container
    | Welcome, #{current_customer.first_name}

app/views/site/my_accounts/order_history.html.slim
-site_title "Order History | Vida Nutriscience"

=render 'welcome'

.page-registration
  .container
    .row
      .col-md-3
        =render 'links'
        
      .col-md-8.col-md-offset-1
        .title.title-sm.text-center.text-uppercase.mb-30 Order History
        table.table-order-history
          -if current_customer.orders.present?
            -current_customer.orders.each do |order|
              tr.row-order-number
                td
                  label.text-uppercase Order Reference No.
                  .data.item =order.request_id
                td.text-right
                  label.text-uppercase Ordered On
                  .data =custom_format_date(order.created_at, '%d %b %Y')
                td.text-right
                  label.text-uppercase Shipping
                  .data.item ₱#{format_number_with_precision(order.shipping_fee, 2)}
                td.text-right
                  label.text-uppercase Amount
                  .data.item ₱#{format_number_with_precision(order.amount, 2)}
                td.text-right
                  label.text-uppercase Status
                  .data.item.text-uppercase style="color: #{order.order_status.color_code}"
                    =order.order_status.name
              /! Order Items - #{order.request_id}
              -order.order_items.each do |item|
                tr.row-sub-items
                  td
                    label.text-uppercase Product
                    .data.item =item.sku.product.name
                  td.text-right
                    label.text-uppercase SKU
                    .data =item.sku.name
                  td.text-right
                    label.text-uppercase No of Items
                    .data =item.quantity
                  td.text-right
                    label.text-uppercase Price
                    .data.item ₱#{format_number_with_precision(item.price, 2)}
                  td.text-right
                    label.text-uppercase Total
                    .data.item ₱#{format_number_with_precision(item.price*item.quantity, 2)}
              /! End Order Items - #{order.request_id}                  
              tr.row-separator
                td colspan="5"
          -else
            tr.row-order-number
              td.text-center
                label.text-uppercase You have not made any purchases yet.
            tr
              td.text-center
                a.btn.btn-gray.btn-lone.text-uppercase href="/shop" Shop Now

app/views/site/my_accounts/show.html.slim
-site_title "My Account | Vida Nutriscience"

=render 'welcome'
    
.page-registration.container-account
  .container
    .row
      .col-md-3
        =render 'links'
        
      .col-md-8.col-md-offset-1
        =form_for @customer, url: my_account_path do |f|
          -if notice.present?
            .alert.alert-custom
              li =notice
          -if @customer.errors.any?
            .alert.alert-custom
              -@customer.errors.full_messages.each do |msg|
                li =msg
          .text-right
            button.btn.btn-green.btn-lone.text-uppercase.save-details Save
          br
          br
          .title.title-sm.text-uppercase Account Details 
          br
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase First Name
                =f.text_field :first_name, class: "form-control", placeholder: "First Name"
                span.error-msg.hidden
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Email
                =f.email_field :email, class: "form-control required", placeholder: "Email", disabled: true
                span.error-msg.hidden
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Middle Name
                =f.text_field :middle_name, class: "form-control", placeholder: "Middle Name"
                span.error-msg.hidden
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Mobile #
                =f.text_field :mobile, class: "form-control", placeholder: "Mobile #"
                span.error-msg.hidden
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Last Name
                =f.text_field :last_name, class: "form-control required", placeholder: "Last Name"
                span.error-msg.hidden
          br
          small.note Enter information here only if you want to change your current password.
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Password
                =f.password_field :password, class: "form-control", placeholder: "New Password"
                span.error-msg.hidden
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Confirm Password
                =f.password_field :password_confirmation, class: "form-control", placeholder: "Confirm Password"
                span.error-msg.hidden
          br
          br
          .title.title-sm.text-uppercase Shipping Info 
          br
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Address 1
                =f.text_area :shipping_address1, class: "form-control required", placeholder: "Address Line 1- Unit # / Floor / Bldg. / Street"
                span.error-msg.hidden
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Address 2
                =f.text_area :shipping_address2, class: "form-control", placeholder: "Address Line 2 - Village / Barangay"
                span.error-msg.hidden
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase City
                =f.text_field :shipping_city, class: "form-control required"
                span.error-msg.hidden
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Province
                =f.text_field :shipping_state, class: "form-control required"
                span.error-msg.hidden
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Zip Code
                =f.text_field :shipping_zip_code, class: "form-control required"
                span.error-msg.hidden
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Country
                =f.select(:shipping_country_code, options_from_collection_for_select(@countries, :code, :name, f.object.shipping_country_code), {include_blank: '-- Select Country --'}, :id=>"country_code", :class =>"form-control required border-gray")
                i.fa.fa-caret-down
                span.error-msg.hidden
          br
          br
        /
          .title.title-sm.text-uppercase Billing Info 
          br
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Address 1
                textarea.form-control type="text"
                span.error-msg.hidden
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Address 2
                textarea.form-control type="text"
                span.error-msg.hidden
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase City
                input.form-control type="text"
                span.error-msg.hidden
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Province
                input.form-control type="text"
                span.error-msg.hidden
          .row
            .col-md-6
              .form-group.form-group-alt
                label.control-label.text-uppercase Country
                input.form-control type="text"
                span.error-msg.hidden